//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "mladen"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  DarkGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame    = PERIOD_CURRENT;
extern int                MomPeriod    =  32;
extern ENUM_APPLIED_PRICE MomPrice     = PRICE_CLOSE;
extern bool               Interpolate  = true;

//
//
//
//
//

double mom[];
double huu[];
double hud[];
double hdd[];
double hdu[];
double slope[];

string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,huu); SetIndexStyle(0,DRAW_HISTOGRAM);
      SetIndexBuffer(1,hud); SetIndexStyle(1,DRAW_HISTOGRAM);
      SetIndexBuffer(2,hdd); SetIndexStyle(2,DRAW_HISTOGRAM);
      SetIndexBuffer(3,hdu); SetIndexStyle(3,DRAW_HISTOGRAM);
      SetIndexBuffer(4,mom);
      SetIndexBuffer(5,slope);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         returnBars        = (TimeFrame==-99);
         TimeFrame         = MathMax(TimeFrame,_Period);
      
      //
      //
      //
      //
      //
   
      IndicatorShortName(timeFrameToString(TimeFrame)+" velocity fl ("+MomPeriod+")");
   return(0);
}
int deinit() { return(0); }


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { huu[0] = limit+1; return(0); }

   //
   //
   //
   //
   //

   if (TimeFrame == Period())
   {
      for(i=limit; i>=0; i--) 
      {
         double atr = iATR(NULL,0,MomPeriod,i);
         if (atr!=0)
               mom[i] = iMomentumS(iMA(NULL,0,1,0,MODE_SMA,MomPrice,i),MomPeriod,1,2,i)/atr;
         else  mom[i] = 0;
         slope[i] = slope[i+1];
         huu[i]   = EMPTY_VALUE;
         hud[i]   = EMPTY_VALUE;
         hdd[i]   = EMPTY_VALUE;
         hdu[i]   = EMPTY_VALUE;
            if (mom[i] > mom[i+1]) slope[i] =  1;
            if (mom[i] < mom[i+1]) slope[i] = -1;
            if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
            if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
            if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
            if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
      }      
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         mom[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,4,y);
         slope[i] = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,MomPeriod,MomPrice,5,y);
         huu[i]   = EMPTY_VALUE;
         hud[i]   = EMPTY_VALUE;
         hdd[i]   = EMPTY_VALUE;
         hdu[i]   = EMPTY_VALUE;
            if (mom[i] > mom[i+1]) slope[i] =  1;
            if (mom[i] < mom[i+1]) slope[i] = -1;
            if (slope[i]== 1 && mom[i]>0) huu[i] = mom[i];
            if (slope[i]==-1 && mom[i]>0) hud[i] = mom[i];
            if (slope[i]==-1 && mom[i]<0) hdd[i] = mom[i];
            if (slope[i]== 1 && mom[i]<0) hdu[i] = mom[i];
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,TimeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               mom[i+k] = mom[i] +(mom[i+n]-mom[i])*k/n;
               if (huu[i]!=EMPTY_VALUE) huu[i+k] = mom[i+k];
               if (hud[i]!=EMPTY_VALUE) hud[i+k] = mom[i+k];
               if (hdu[i]!=EMPTY_VALUE) hdu[i+k] = mom[i+k];
               if (hdd[i]!=EMPTY_VALUE) hdd[i+k] = mom[i+k];
            }
   }
   return(0);
}

//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workMom[];
double iMomentumS(double price, double length, double powSlow, double powFast, int i)
{
   if (ArraySize(workMom)!=Bars) ArrayResize(workMom,Bars);
      i = Bars-i-1; workMom[i] = price;
      
      //
      //
      //
      //
      //
      
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;
         for(int k=0; k<length; k++)
         {
            double weight = length-k;
               suma  += workMom[i-k] * MathPow(weight,powSlow);
               sumb  += workMom[i-k] * MathPow(weight,powFast);
               sumwa += MathPow(weight,powSlow);
               sumwb += MathPow(weight,powFast);
         }
   return(sumb/sumwb-suma/sumwa);
}  


//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}